									// **** Image includes

#ifndef IMAGE_EXT_DEF
	#define	IMAGE_EXT_DEF

	#include <stdio.h>
	#include <stdlib.h>
	#include <conio.h>
	
	#include "buffer.h"
	#include "file.h"
	#include "image.h"

	#define IMAGE_EXT_SUPPORT_TIFF

	#define CHAN_RED		0	
	#define CHAN_GREEN		1
	#define CHAN_BLUE		2
	#define CHAN_ALPHA		3
	#define CHAN_GRAY		4
	
	class ImageExt {
	public:
		ImageExt ();
		ImageExt (Image* pImg);
		~ImageExt ();
		void Load (char *filename, Image *img);
	private:
		#ifdef IMAGE_EXT_SUPPORT_TIFF
			void LoadTiff (char *filename, Image *img);
			void SaveTiff (char *filename, Image *img);
			void LoadTiffDirectory (File &tiff, Buffer &code);
			void LoadTiffEntry (File &tiff, Buffer &code);
			void LoadTiffStrips (File &tiff, Buffer &code);
			void LoadTiffData (File &tiff, Buffer &code, unsigned long count, unsigned long offset, int row);
			void SaveTiffDirectory (File &tiff, Buffer &code);
			void SaveTiffEntry (File &tiff, Buffer &code, unsigned int tag);
			void SaveTiffExtras (File &tiff, Buffer &code, unsigned int tag);
			void SaveTiffData (File &tiff, Buffer &code);			
		#endif

		Image*				m_pImg;					// Pointer to an ImageX		
		char				m_filename[100];		// Filename of ImageX
		int					m_status;				// Status of ImageX
		
		#ifdef IMAGE_EXT_SUPPORT_TIFF				//**** TIFF Format Info
			int				m_xres, m_yres;			// TIFF Resolution
			int				m_ops;					// TIFF Pixel-Format Options for ImageX
			int				m_mode;					// TIFF Mode
			int				m_alpha;				// TIFF Alpha Channel Present?
			int				m_num_chan;				// TIFF Number of Channels
			unsigned long	m_bpcoff;				// TIFF 
			int				m_bpc[5];				// TIFF Bits per Channel
			int				m_compress;				// TIFF Compressed?
			int				m_photo;
			unsigned long	m_num_strips;			// TIFF Number of Strips
			unsigned long	m_strip_offsets;		// TIFF Strip Offsets
			unsigned long	m_strip_counts;			// TIFF Strip Counts
			int				m_rps;					// TIFF Rows per Strip
			int				m_bpp;					// TIFF Bits per Pixel
			int				m_bpr;					// TIFF Bits per Row
		#endif
	};
#endif
