
#include <conio.h>
#include <stdio.h>
#include <winsock2.h>
#include <time.h>

#include "neteng.h"

NetEng::NetEng ()
{
	mode = NET_NO_MODE;
	state = NET_OFF;
	max_net_sockets = 0;
	num_net_sockets = 0;
	net_sockets = NULL;
	buf_pos = buf;
	buf_data.dat = NULL;
	buf_data.dat_len = 0;
	buf_len = 0;
}

// Start Network Engine - Initialize winsock and enter NET_START state as client or server
void NetEng::Start (char m)
{	
	FD_ZERO (&socket_set);

	output.CreateConsole (25, 80);

	WSADATA WSAData;
	int status;
    if ((status = WSAStartup(MAKEWORD(1,1), &WSAData)) == 0) {
		output.AddLine ("Start: Started winsock...\n");
		mode = m;
		state = NET_START;
	} else {
		output.AddLine ("Start: Very very bad! Unable to start up winsock\n");
		state = NET_OFF;
	}
}

void NetEng::Go (void)
{
	if (mode==NET_CLIENT) {
		switch (state) {
		case NET_OFF: break;
		case NET_START: ClientStart (); break;
		case NET_RESET: ClientReset (); break;
		case NET_SEARCHING: ClientSearching (); break;
		case NET_CONNECTING: ClientConnecting (); break;
		case NET_CONNECTED: ClientConnected (); break;
		}
	} else {
		switch (state) {
		case NET_OFF: break;
		case NET_START: ServerStart (); break;
		case NET_RESET: ServerReset (); break;
		case NET_PROCESSING: ServerProcessing (); break;
		}
	}
}

void NetEng::ClientStart (void)
{
	AddSocket (NET_UDP);
	output.AddLine ("cStart: Created socket.\n");
	state = NET_RESET;
	client_sn = 0;
}

void NetEng::ClientReset (void)
{
	output.AddLine ("cReset: Reseting socket.\n");
	SetSocketMode (0, NET_BROADCAST_ON);
	SetSocketDestBroadcast (0, NET_SEARCH_PORT);	
	SetSocketTimeout (0, 0, 0);
	SetSocketSendTime (0, clock());

	state = NET_SEARCHING;
}

void NetEng::ClientSearching (void)
{	
	if (Recieve() > 0) {
		if (strncmp (buf, "sFND", 4)==0) {
			output.AddLine ("cSearching: Server responded.");
			SetSocketSrcToDest (0, 0);
			SetSocketMode (0, NET_BROADCAST_OFF);
			SetSocketSendTime (0, clock()-CLOCKS_PER_SEC*3);
			state = NET_CONNECTING;
		}		
	} else if (clock() - GetSocketSendTime(0) > CLOCKS_PER_SEC) {
		output.AddLine ("cSearching: Searching...");			
		Send (0, "cSRCH", 5);
	}
}

void NetEng::ClientConnecting (void)
{
	if (Recieve() > 0) {
		if (strncmp (buf, "sOK", 3)==0) {
			unsigned int ok_port = atoi (buf+3);
			
			char disp[100];
			sprintf (disp, "cConnecting: Server says OK to connect. %u", ok_port);
			output.AddLine (disp);
			
			SetSocketMode (0, NET_BROADCAST_OFF);	
			SetSocketSrcToDest (0, 0);					
			SetSocketDestPort (0, ok_port);			
			SocketConnectToDest (0);
			
			char sendbuf[20];		
			sprintf (sendbuf, "cCTD?%u", ok_port);		// Make sure we're connected
			Send (0, sendbuf, strlen(sendbuf)+1);
		} else if (strncmp (buf, "sCTD", 4)==0) {			
			client_sn = (int) atoi (buf+4);
			
			char disp[100];
			sprintf (disp, "cConnecting: Server says were connected at %d!", client_sn);
			output.AddLine (disp);

			state = NET_CONNECTED;
		} else if (strncmp (buf, "sNCTD", 5)==0) {
			char disp[100];
			sprintf (disp, "cConnecting: Server says were NOT connected");
			output.AddLine (disp);
			state = NET_OFF;
		}
	} else if (clock() - GetSocketSendTime(0) > CLOCKS_PER_SEC*3) {
		output.AddLine ("cConnecting: Connecting...\n");
		char disp[20];
		sprintf (disp, "cCNCT%s", "rama");
		Send (0, disp, strlen(disp)+1);
	}
}

void NetEng::ClientConnected (void)
{
	if (Recieve () > 0) {		
		if (strncmp(buf, "DAT", 3)==0) {
			buf_data.dat = buf + 3;
			buf_data.dat_len = -1;
			buf_len -= 3;
		}
	}
}

void NetEng::ServerStart (void)
{
	AddSocket (NET_UDP);
	output.AddLine ("sStart: Created socket.");
	state = NET_RESET;
	client_sn = 0;
}

void NetEng::ServerReset (void)
{
	output.AddLine ("sReset: Reseting socket.");
	SetSocketMode (0, NET_BROADCAST_OFF);
	SetSocketSrcAny (0, NET_SEARCH_PORT);
	SocketBindToSrc (0);
	SetSocketTimeout (0, 0, 0);

	serv_port = NET_SEARCH_PORT + 1;	
	state = NET_PROCESSING;
}	

void NetEng::ServerProcessing (void)
{
	if (Recieve() > 0) {					// Receive data on all sockets
		if (strncmp (buf, "DAT", 3)==0) {
			buf_data.dat = buf+3;
			buf_data.dat_len = -1;
			buf_len -= 3;
		} else if (strncmp (buf, "cSRCH", 5)==0) {
			output.AddLine ("sProcessing: Client found search for server.");
			SetSocketSrcToDest (0, 0);
			Send (0, "sFND", 4);			
		} else if (strncmp (buf, "cCNCT", 5)==0) {
			char disp[100];
			unsigned long displen = 100;
			GetSocketSrcName (0, disp, &displen); 
			
			output.AddLine ("sProcessing: Client requesting to connect.");

			SetSocketSrcToDest (0, 0);			
			int s = AddSocket (NET_UDP);			// Create new socket for client
			SetSocketSrcAny (s, serv_port);
			SetSocketSrcPort (s, serv_port);			
			SetSocketMode (s, NET_BROADCAST_OFF);	// Direct, no broadcasting. 
			SetSocketTimeout (s, 0, 0);
			SocketBindToSrc (s);					// Bind socket to this address & port only.
			
			char sendbuf[20];
			sprintf (sendbuf, "sOK%u", serv_port);	// Tell client it is connected.
			Send (0, sendbuf, strlen(sendbuf)+1);		// WE ARE >NOT< YET SENDING ON NEW CLIENT SOCKET HERE
			serv_port++;
		} else if (strncmp (buf, "cCTD?", 5)==0) {
			unsigned int chk_port = atoi (buf+5);
			char disp[100];
			sprintf (disp, "sProcessing: Client confirming connection on %u", chk_port);
			output.AddLine (disp);
			
			int s = FindSocketWithSrcPort (chk_port);
			if (s > 0) {
				SetSocketSrcToDest (s, s);
				SocketConnectToDest (s);
				
				char sendbuf[20];
				sprintf (sendbuf, "sCTD%d", s);
				Send (s, sendbuf, strlen(sendbuf)+1);

				sprintf (disp, "sProcessing: Client confirmed on socket %d, port %u ", s, chk_port);
				output.AddLine (disp);
			} else {
				Send (s, "sNCTD", 5);			
			}
		}
	}	
}

int NetEng::AddSocket (char protocol)
{
	if (num_net_sockets==max_net_sockets) {
		if (max_net_sockets==0) max_net_sockets = 1; else max_net_sockets <<= 1;
		NetSock* new_list = new NetSock[max_net_sockets];
		if (net_sockets!=NULL) {
			memcpy (new_list, net_sockets, num_net_sockets*sizeof(NetSock));
			delete [] net_sockets;
		}
		net_sockets = new_list;
	}
	net_sockets[num_net_sockets].Create (protocol);
	num_net_sockets++;
	return num_net_sockets-1;
}

int	NetEng::FindSocketWithSrcPort (int chk_port)
{
	NetAddress d;	
	for (int n=0; n < num_net_sockets; n++) {
		d = GetSocketSrc (n);
		if (d.GetPort () == chk_port) return n;
	}
	return -1;
}

int NetEng::Recieve (void)
{
	int result;

	FD_ZERO (&socket_set);
	for (int n=0; n < num_net_sockets; n++) FD_SET (net_sockets[n].GetSocket(), &socket_set);

	result = select (1, &socket_set, NULL, NULL, net_sockets[0].GetTimeoutMdfy());
	if (result > 0) {
		//result = 0;
		if (++curr_socket >= num_net_sockets) curr_socket = 0;
		while (FD_ISSET(net_sockets[curr_socket].GetSocket(), &socket_set)==0)
			if (++curr_socket >= num_net_sockets) curr_socket = 0;
		
		if (net_sockets[curr_socket].GetConnected()) buf_len = net_sockets[curr_socket].RecvData (buf, NET_BUFSIZE);
		else										buf_len = net_sockets[curr_socket].RecvDataFrom (buf, NET_BUFSIZE);
		
		return buf_len;
	}
	return 0;
}

int NetEng::Send (int sn, char* buf, int len)
{
	if (GetSocketConnected(sn)) 	return SocketSendData (sn, buf, len);
	else							return SocketSendDataTo (sn, buf, len);
}

void NetEng::StartDatagram (void)
{
	*buf = 'D'; *(buf+1) = 'A'; *(buf+2) = 'T';
	buf_len = 3;
	buf_pos = buf+3;

	buf_data.dat = buf_pos+sizeof(int);
	buf_data.dat_len = 0;
}

NetData* NetEng::StartMessage (void)
{
	buf_data.dat_len = 0;
	return &buf_data;
}

void NetEng::StopMessage (void)
{
	buf_len += buf_data.dat_len + sizeof(int);
	*(int*) buf_pos = buf_data.dat_len;
	buf_pos += buf_data.dat_len + sizeof(int);
}

void NetEng::SendDatagram (int s)
{
	if (s==-1) {
		for (int sn=1; sn < num_net_sockets; sn++) 
			Send (sn, buf, buf_len);
	} else {
		Send (s, buf, buf_len);
	}
}

NetData* NetEng::RecvMessage (void)
{
	if (buf_len==0) {buf_data.dat_len = 0; buf_data.dat = NULL; return &buf_data;}
	if (buf_data.dat_len==-1) {
		buf_len -= sizeof(int);
		buf_data.dat_len = * (int*) buf_data.dat;
		buf_data.dat += sizeof(int);		
	} else if (buf_data.dat_len > 0) {
		buf_len -= buf_data.dat_len + sizeof(int);
		if (buf_len > 0) {
			buf_data.dat += buf_data.dat_len;
			buf_data.dat_len = * (int*) buf_data.dat;
			buf_data.dat += sizeof(int);
		} else {
			buf_len = 0;
			buf_data.dat = NULL;
			buf_data.dat_len = 0;
		}
	}
	return &buf_data;
}



/*
	neteng.StartDatagram ()
	for (n=1; n<5) {
		dat = neteng.StartMessage ();
		dat.AttachInt (3);
		dat.AttachInt (4);
		dat.AttachFloat (5);
		neteng.StopMessage ();
	}
	neteng.SendDatagram (1);
*/
