
#ifndef SHIPENG_DEF

	#include "shipnet-ship.h"
	#include "shipnet-particles.h"

	#define LATENCY				1

	#define MAX_SHIPS			10

	#define STATE_NEEDNAME		0				// ShipEng States
	#define STATE_PLAY			1

	#define SHIP_UPDATE_MSG		1
	#define SHIP_NAME_MSG		2
	#define SHIP_MOVE_MSG		3		
	#define PHOTON_MSG			4
	#define COLLISION_MSG		5

	#define SHIP_SIZE			30.0	
	#define SHIELD_SIZE			50.0
	#define PARTICLE_SIZE		15.0
	
	

	class NetEng;
	class NetData;
	
	class ShipEng {
	public:
			void Initialize (bool i_am_client, NetEng* eng);
			
			void ClientGo  (void);
			void ClientProcessInput (void);
			void ClientRecieve (void);
			void ClientRecvShipUpdateMsg (NetData* dat);
			void ClientRecvShipNameMsg (NetData* dat);
			void ClientRecvPhotonMsg (NetData* dat);
			void ClientRecvCollisionMsg (NetData* dat);
			void ClientSendShipNameMsg (void);
			void ClientSendShipMoveMsg (void);
			void ClientSendPhotonMsg (float x, float y, float dx, float dy);
			void ClientSendCollisionMsg (int a, int b);

			void ClientDetectCollisions (void);
			
			void ServerGo (void);
			void ServerRecieve (void);
			void ServerRecvShipMoveMsg (NetData* dat);
			void ServerFwdCollisionMsg (NetData* dat);
			void ServerFwdShipNameMsg (NetData* dat);
			void ServerFwdPhotonMsg (NetData* dat); 
			void ServerSendShipUpdateMsg (void);		

			void DrawNetEng (void);
	private:
			int			m_state;
			int			m_frame;

			int			m_num_ships;
			int			m_client_ship;
			Ship		m_ship[10];				// Ship objects
			Particles	m_particles;			// Photon objects
			Image		m_back_img;				// Background Image	

			NetEng*		m_neteng;
			int			m_last_update_frame;
			int			m_update_data;

			char		m_getname[100];
			char*		m_getname_pos;

			Image		m_ship_shields[4];

			SoundX		m_photon_sound;
			SoundX		m_engine_sound;
			SoundX		m_engineother_sound;
	};		

#endif
