//
// GameX
// Ship Demo - Main Program
// 
// Copyright (C) 2002 Rama C. Hoetzlein
// 
// This software is released under the GameX GNU GPL 
// Open Source Liscense. See the GameX documentation included
// with this source code for terms of modification, 
// distribution and re-release. 
// 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <process.h>

#include "neteng.h"
#define WINGL_MAIN
#include "win.h"

#include "shipnet-eng.h"

NetEng net_eng;
ShipEng ship_eng;
bool i_am_client;

// GameX initialize function (called when program starts)
void initialize (void)
{
	int result = MessageBox (WinGL.GetWindow(), "Start client?", "", MB_YESNO);
	if (result==IDYES)	{
		i_am_client = true; 
		net_eng.Start (NET_CLIENT);
		int full = MessageBox (WinGL.GetWindow(), "Start full screen?", "", MB_YESNO);
		if (full==IDYES) {
			WinGL.Initialize (true, 1024, 768, 16);
		} else {
			WinGL.Initialize (false, 400, 400, 16);			
		}
	} else {
		i_am_client = false; 
		net_eng.Start (NET_SERVER);
		WinGL.Initialize (false, 400, 200, 0);
	}

	
	ship_eng.Initialize (i_am_client, &net_eng);
}

void main (void)
{
	if (i_am_client) {
		ship_eng.ClientGo ();
	} else {
		ship_eng.ServerGo ();
	}
}


