
#ifndef SHIPDEMO_PHOTONS
	#define SHIPDEMO_PHOTONS

	#include "win-gl.h"

	#define P_PHOTON		0
	#define P_EXPLOSION		1
	#define P_REMNANT		2
							
	// Photons are implemented as a simple particle system. 	

	struct Particle {						//*** Photon structure
		char		src_ship;
		char		kind;
		float		x, y;				// Position of photon (2D)
		float		dx, dy;				// Velocity of photon
		int			age;				// Age of photon
		int			phase;
		int			img;				// Image number of photon (not used)
	};

	class Particles {						//*** Photon class
	public:
		void Initialize (void);			// Initialize photons
		void Move (void);				// Move all photons
		void Draw (float dx, float dy, int frame);			// Draw all photons

		int DetectCollisions (char chk_ship, float sx, float sy, float sdx, float sdy, float* ang);

										// Add a photon to the system
		int AddPhoton (char ship, float new_x, float new_y, float new_dx, float new_dy);		
		int AddExplosion (char ship, float new_x, float new_y, float new_dx, float new_dy);
	private:
		int			num_particles;		// Current number of photons
		int			max_particles;		// Maximum number of photons
		Particle*	particle_list;		// List of photons (ie. 'the particle system')

		Image		photon_img[30];		// Photon images 
		Image		explosion_img[30];	// Explosion images
	};

	

#endif