


#ifndef SHIPDEMO_PHOTONS
	#define SHIPDEMO_PHOTONS

	#include "win-gl.h"
							
	// Photons are implemented as a simple particle system. 	

	struct Particle {						//*** Photon structure
		float		x, y;				// Position of photon (2D)
		float		dx, dy;				// Velocity of photon
		int			age;				// Age of photon
		int			phase;
		int			img;				// Image number of photon (not used)
	};

	class Particles {						//*** Photon class
	public:
		void Initialize (void);			// Initialize photons
		void Move (void);				// Move all photons
		void Draw (float dx, float dy, int frame);			// Draw all photons

										// Add a photon to the system
		int AddPhoton (float new_x, float new_y, float new_dx, float new_dy);		
	private:
		int			num_particles;		// Current number of photons
		int			max_particles;		// Maximum number of photons
		Particle*	particle_list;		// List of photons (ie. 'the particle system')

		Image		photon_img[30];		// Photon images 
		Image		explosion_img[30];	// Explosion images
	};

	

#endif