

#ifndef SHIPDEMO_SHIP
	#define SHIPDEMO_SHIP

	#include "win-gl.h"

	#include "shipnet-particles.h"

												//*** Ship Images
	#define SHIP_IMG_LEFT			0
	#define SHIP_IMG_FLAT			8
	#define SHIP_IMG_RIGHT			16
	#define SHIP_IMG_SHADOW			17
	#define SHIP_IMG_SKID			18	

											//*** Ship States
	#define SHIP_STATE_NORMAL		0		// Normal Flight
	#define SHIP_STATE_BANKLEFT		1		// Banking Left
	#define SHIP_STATE_BANKRIGHT	2		// Banding Right

	class Ship {
	public:
		void Initialize (int num);
		
		void Move (void);
		void UpdateShipByInput (bool l, bool r, bool u, bool d, bool sl, bool sr);		
		void UpdateShipByData (float nx, float ny, float ndx, float ndy, float nv, float ns);
		void UpdateShipByData (float ndt, float nx, float ny, float ndx, float ndy, float nva, float nsp, float nta, float ntda);
		
		void Draw (float dx, float dy, int frame, Image* shield_imgs);
				
		//void Collisions (Ship* ship2);		// Collision Detection with another ship
			
		float GetX (void) {return m_x;}		// Get position and velocity of ship
		float GetY (void) {return m_y;}
		float GetDX (void) {return m_dx;}
		float GetDY (void) {return m_dy;}
		float GetDT (void) {return m_dt;}	
		float GetTurnA (void) {return m_turn_a;}
		float GetTurnDA (void) {return m_turn_da;}
		float GetVelA (void) {return m_vel_a;}
		float GetSpeed (void) {return m_speed;}
		
		void SetDT (float dt)	{m_dt = dt;}
		void SetTurnA (float a)	{m_turn_a = a;}
		void SetTurnDA (float da) {m_turn_da = da;}
		
		int GetLastSendTime (void) {return last_send_time;}
		void SetLastSendTime (int t) {last_send_time = t;}

		void ActivateShields (float ang)		{m_shield_on = 3; m_shield_ang = ang;}

		void SetName (char* n)	{strcpy (name, n);}
		char* GetName (void)	{return name;}
	public:
		char		name[100];

		int			last_send_time;

		int			m_frags;
		int			m_health;
		int			m_shield;
		int			m_shield_on;
		float		m_shield_ang;
		int			m_ship_num;				// Current ship number		
		float		m_dt;
		int			m_state;		
		float		m_x, m_dx;				// Ship position
		float		m_y, m_dy;
		float		m_speed;				// Ship speed
		float		m_max_speed;
		float		m_vel_a;				// Ship velocity angle
		float		m_turn_a, m_turn_da;	// Ship turn angle
		int			m_refire;					// Refire counter for ship
				
		int			m_curr_img;				// Current ship image

		Image		ships[30];	
		Image		ship_rotated;
		Image		target;
	};

#endif
